<?php

declare(strict_types=1);

namespace App\Repository;

final class TblNivelEducativoRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblNivelEducativoId): object
    {
        $query = 'SELECT * FROM `TblNivelEducativo` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblNivelEducativoId);
        $statement->execute();
        $TblNivelEducativo = $statement->fetchObject();
        if (! $TblNivelEducativo) {
            throw new \Exception('TblNivelEducativo not found.', 404);
        }

        return $TblNivelEducativo;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblNivelEducativo` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblNivelEducativo): object
    {
        $query = 'INSERT INTO `TblNivelEducativo` (`Nivel`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:Nivel, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblNivelEducativo->id);
//         $statement->bindParam('fecha', $TblNivelEducativo->fecha);
        $statement->bindParam('Nivel', $TblNivelEducativo->Nivel);
        $statement->bindParam('field1', $TblNivelEducativo->field1);
        $statement->bindParam('field2', $TblNivelEducativo->field2);
        $statement->bindParam('field3', $TblNivelEducativo->field3);
        $statement->bindParam('field4', $TblNivelEducativo->field4);
        $statement->bindParam('field5', $TblNivelEducativo->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblNivelEducativo, object $data): object
    {
        if (isset($data->fecha)) {
            $TblNivelEducativo->fecha = $data->fecha;
        }
        if (isset($data->Nivel)) {
            $TblNivelEducativo->Nivel = $data->Nivel;
        }
        if (isset($data->field1)) {
            $TblNivelEducativo->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblNivelEducativo->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblNivelEducativo->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblNivelEducativo->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblNivelEducativo->field5 = $data->field5;
        }

        $query = 'UPDATE `TblNivelEducativo` SET `fecha` = :fecha, `Nivel` = :Nivel, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblNivelEducativo->id);
        $statement->bindParam('fecha', $TblNivelEducativo->fecha);
        $statement->bindParam('Nivel', $TblNivelEducativo->Nivel);
        $statement->bindParam('field1', $TblNivelEducativo->field1);
        $statement->bindParam('field2', $TblNivelEducativo->field2);
        $statement->bindParam('field3', $TblNivelEducativo->field3);
        $statement->bindParam('field4', $TblNivelEducativo->field4);
        $statement->bindParam('field5', $TblNivelEducativo->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblNivelEducativo->id);
    }

    public function delete(int $TblNivelEducativoId): void
    {
        $query = 'DELETE FROM `TblNivelEducativo` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblNivelEducativoId);
        $statement->execute();
    }
}
